Option Explicit On
Option Strict On
Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Runtime.InteropServices

<ComVisible(True)> _
Public Class WebBrowserController
	Inherits Control
	Implements IOleClientSite
	Implements IDocHostShowUI

	Private _WebBrowser As WebBrowser
	Public Event ShowHelp(ByVal sender As Object, ByVal e As ShowHelpEventArgs)
	Public Event ShowMessage(ByVal sender As Object, ByVal e As ShowMessageEventArgs)

	Public Sub New(ByVal WebBrowser As WebBrowser)
		Me._WebBrowser = WebBrowser
		DirectCast(Me._WebBrowser.ActiveXInstance, IOleObject).SetClientSite(Me)
	End Sub

#Region "Cxg nh [ShowHelpEventArgs]"
	Public Class ShowHelpEventArgs

		Private _handled As Boolean = False
		Public Property Handled() As Boolean
			Get
				Return _handled
			End Get
			Set(ByVal value As Boolean)
				_handled = value
			End Set
		End Property

		Private _hwnd As IntPtr
		Public Property Handle() As IntPtr
			Get
				Return _hwnd
			End Get
			Private Set(ByVal value As IntPtr)
				_hwnd = value
			End Set
		End Property

		Private _pszHelpFile As String
		Public Property HelpFile() As String
			Get
				Return _pszHelpFile
			End Get
			Private Set(ByVal value As String)
				_pszHelpFile = value
			End Set
		End Property

		Private _uCommand As UInteger
		Public Property Command() As UInteger
			Get
				Return _uCommand
			End Get
			Private Set(ByVal value As UInteger)
				_uCommand = value
			End Set
		End Property

		Private _dwData As UInteger
		Public Property Data() As UInteger
			Get
				Return _dwData
			End Get
			Private Set(ByVal value As UInteger)
				_dwData = value
			End Set
		End Property

		Private _ptMouse As Point
		Public Property Mouse() As Point
			Get
				Return _ptMouse
			End Get
			Private Set(ByVal value As Point)
				_ptMouse = value
			End Set
		End Property

		Private _pDispatchObjectHit As Object
		Public Property DispatchObjectHit() As Object
			Get
				Return _pDispatchObjectHit
			End Get
			Set(ByVal value As Object)
				_pDispatchObjectHit = value
			End Set
		End Property

		Public Sub New( _
			ByVal hwnd As IntPtr, _
			ByVal pszHelpFile As String, _
			ByVal uCommand As UInteger, _
			ByVal dwData As UInteger, _
			ByVal ptMouse As Point, _
			ByVal pDispatchObjectHit As Object)

			Me.Handle = hwnd
			Me.HelpFile = pszHelpFile
			Me.Command = Command
			Me.Data = dwData
			Me.Mouse = ptMouse
			Me.DispatchObjectHit = pDispatchObjectHit
		End Sub
	End Class
#End Region 

#Region "Cxg nh [ShowMessageEventArgs"
	Public Class ShowMessageEventArgs
		Private _handled As Boolean = False
		Public Property Handled() As Boolean
			Get
				Return _handled
			End Get
			Set(ByVal value As Boolean)
				_handled = value
			End Set
		End Property

		Private _hwnd As IntPtr
		Public Property Handle() As IntPtr
			Get
				Return _hwnd
			End Get
			Private Set(ByVal value As IntPtr)
				_hwnd = value
			End Set
		End Property

		Private _lpstrText As String
		Public Property Text() As String
			Get
				Return _lpstrText
			End Get
			Private Set(ByVal value As String)
				_lpstrText = value
			End Set
		End Property

		Private _lpstrCaption As String
		Public Property Caption() As String
			Get
				Return _lpstrCaption
			End Get
			Private Set(ByVal value As String)
				_lpstrCaption = value
			End Set
		End Property

		Private _dwType As MsgBoxStyle  'As UInteger
		Public Property Type() As MsgBoxStyle   'As UInteger
			Get
				Return _dwType
			End Get
			'Private Set(ByVal value As UInteger)
			Private Set(ByVal value As MsgBoxStyle)
				_dwType = value
			End Set
		End Property

		Private _lpstrHelpFile As String
		Public Property HelpFile() As String
			Get
				Return _lpstrHelpFile
			End Get
			Private Set(ByVal value As String)
				_lpstrHelpFile = value
			End Set
		End Property

		Private _dwHelpContext As UInteger
		Public Property HelpContext() As UInteger
			Get
				Return _dwHelpContext
			End Get
			Private Set(ByVal value As UInteger)
				_dwHelpContext = value
			End Set
		End Property

		Private _lpResult As Integer
		Public Property Result() As Integer
			Get
				Return _lpResult
			End Get
			Set(ByVal value As Integer)
				_lpResult = value
			End Set
		End Property

		Public Sub New( _
			ByVal hwnd As IntPtr, _
			ByVal lpstrText As String, _
			ByVal lpstrCaption As String, _
			ByVal dwType As MsgBoxStyle, _
			ByVal lpstrHelpFile As String, _
			ByVal dwHelpContext As UInteger, _
			ByRef lpResult As Integer)

			Me.Handle = hwnd
			Me.Text = lpstrText
			Me.Caption = lpstrCaption
			Me.Type = dwType
			Me.HelpFile = lpstrHelpFile
			Me.HelpContext = dwHelpContext
			Me.Result = lpResult
		End Sub
	End Class
#End Region

#Region "IDocHostShowUI C^[tFCX̎"
	Private Function ShowHelpInternal(ByVal hwnd As IntPtr, ByVal pszHelpFile As String, ByVal uCommand As UInteger, ByVal dwData As UInteger, ByVal ptMouse As tagPOINT, ByVal pDispatchObjectHit As Object) As Integer Implements IDocHostShowUI.ShowHelp
		Dim e As New ShowHelpEventArgs(hwnd, pszHelpFile, uCommand, dwData, New Point(ptMouse.x, ptMouse.y), pDispatchObjectHit)
		RaiseEvent ShowHelp(Me, e)
		pDispatchObjectHit = e.DispatchObjectHit
		If e.Handled Then
			Return 0	'S_OK 
		Else
			Return 1	'S_FALSE
		End If
	End Function

	Private Function ShowMessageInternal(ByVal hwnd As IntPtr, ByVal lpstrText As String, ByVal lpstrCaption As String, ByVal dwType As MsgBoxStyle, ByVal lpstrHelpFile As String, ByVal dwHelpContext As UInteger, ByRef lpResult As Integer) As Integer Implements IDocHostShowUI.ShowMessage
		Dim e As New ShowMessageEventArgs(hwnd, lpstrText, lpstrCaption, dwType, lpstrHelpFile, dwHelpContext, lpResult)
		RaiseEvent ShowMessage(Me, e)
		lpResult = e.Result
		If e.Handled Then
			Return 0	'S_OK 
		Else
			Return 1	'S_FALSE
		End If
	End Function
#End Region

#Region "IOleClientSite C^[tFCX̎"
	Public Sub GetContainer(ByRef ppContainer As Object) Implements IOleClientSite.GetContainer
	End Sub
	Public Sub GetMoniker(ByVal dwAssign As Integer, ByVal dwWhichMoniker As Integer, ByRef ppmk As Object) Implements IOleClientSite.GetMoniker
	End Sub
	Public Sub OnShowWindow(ByVal fShow As Boolean) Implements IOleClientSite.OnShowWindow
	End Sub
	Public Sub RequestNewObjectLayout() Implements IOleClientSite.RequestNewObjectLayout
	End Sub
	Public Sub SaveObject() Implements IOleClientSite.SaveObject
	End Sub
	Public Sub ShowObject() Implements IOleClientSite.ShowObject
	End Sub
#End Region
End Class


<GuidAttribute("B196B288-BAB4-101A-B69C-00AA00341D07")> _
<InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)> _
Public Interface IOleControl
	Sub GetControlInfo(ByRef pCI As Object)
	Sub OnMnemonic(ByRef pMsg As Object)
	Sub OnAmbientPropertyChange(ByVal dispID As Integer)
	Sub FreezeEvents(ByVal bFreeze As Boolean)
End Interface

<Guid("00000118-0000-0000-C000-000000000046")> _
<InterfaceType(ComInterfaceType.InterfaceIsIUnknown)> _
Public Interface IOleClientSite
	Sub SaveObject()
	Sub GetMoniker(ByVal dwAssign As Integer, ByVal dwWhichMoniker As Integer, ByRef ppmk As Object)
	Sub GetContainer(ByRef ppContainer As Object)
	Sub ShowObject()
	Sub OnShowWindow(ByVal fShow As Boolean)
	Sub RequestNewObjectLayout()
End Interface

<Guid("00000112-0000-0000-C000-000000000046")> _
<InterfaceType(ComInterfaceType.InterfaceIsIUnknown)> _
Public Interface IOleObject
	Sub SetClientSite(ByVal pClientSite As IOleClientSite)
	Sub GetClientSite(ByRef ppClientSite As IOleClientSite)
	Sub SetHostNames(ByVal szContainerApp As Object, ByVal szContainerObj As Object)
	Sub Close(ByVal dwSaveOption As Integer)
	Sub SetMoniker(ByVal dwWhichMoniker As Integer, ByVal pmk As Object)
	Sub GetMoniker(ByVal dwAssign As Integer, ByVal dwWhichMoniker As Integer, ByVal ppmk As Object)
	Sub InitFromData(ByVal pDataObject As IDataObject, ByVal fCreation As Boolean, ByVal dwReserved As Integer)
	Sub GetClipboardData(ByVal dwReserved As Integer, ByRef ppDataObject As IDataObject)
	Sub DoVerb(ByVal iVerb As Integer, ByVal lpmsg As Integer, ByVal pActiveSite As Object, ByVal lindex As Integer, ByVal hwndParent As Integer, ByVal lprcPosRect As Integer)
	Sub EnumVerbs(ByRef ppEnumOleVerb As Object)
	Sub Update()
	Sub IsUpToDate()
	Sub GetUserClassID(ByVal pClsid As Integer)
	Sub GetUserType(ByVal dwFormOfType As Integer, ByVal pszUserType As Integer)
	Sub SetExtent(ByVal dwDrawAspect As Integer, ByVal psizel As Integer)
	Sub GetExtent(ByVal dwDrawAspect As Integer, ByVal psizel As Integer)
	Sub Advise(ByVal pAdvSink As Object, ByVal pdwConnection As Integer)
	Sub Unadvise(ByVal dwConnection As Integer)
	Sub EnumAdvise(ByRef ppenumAdvise As Object)
	Sub GetMiscStatus(ByVal dwAspect As Integer, ByVal pdwStatus As Integer)
	Sub SetColorScheme(ByVal pLogpal As Object)
End Interface


Public Structure tagPOINT
	Public x As Integer
	Public y As Integer
End Structure

<ComImport(), ComVisible(True)> _
<Guid("C4D244B0-D43E-11CF-893B-00AA00BDCE1A")> _
<InterfaceType(ComInterfaceType.InterfaceIsIUnknown)> _
Public Interface IDocHostShowUI
	<PreserveSig()> Function ShowMessage( _
		ByVal hwnd As IntPtr, _
		<MarshalAs(UnmanagedType.LPWStr)> ByVal lpstrText As String, _
		<MarshalAs(UnmanagedType.LPWStr)> ByVal lpstrCaption As String, _
		<MarshalAs(UnmanagedType.U4)> ByVal dwType As MsgBoxStyle, _
		<MarshalAs(UnmanagedType.LPWStr)> ByVal lpstrHelpFile As String, _
		<MarshalAs(UnmanagedType.U4)> ByVal dwHelpContext As UInteger, _
		<[In](), Out()> ByRef lpResult As Integer _
	) As <MarshalAs(UnmanagedType.I4)> Integer

	<PreserveSig()> Function ShowHelp( _
		ByVal hwnd As IntPtr, _
			<MarshalAs(UnmanagedType.LPWStr)> ByVal pszHelpFile As String, _
			<MarshalAs(UnmanagedType.U4)> ByVal uCommand As UInteger, _
			<MarshalAs(UnmanagedType.U4)> ByVal dwData As UInteger, _
			<[In](), MarshalAs(UnmanagedType.Struct)> ByVal ptMouse As tagPOINT, _
			<Out(), MarshalAs(UnmanagedType.IDispatch)> ByVal pDispatchObjectHit As Object _
	) As <MarshalAs(UnmanagedType.I4)> Integer
End Interface
